// SPDX-License-Identifier: MIT
pragma solidity 0.8.16;

import "../structures/CrossChainMessage.sol";

interface ICCMPRouterAdaptor {
    function verifyPayload(
        CCMPMessage calldata _ccmpMessage,
        bytes calldata _verificationData
    ) external returns (bool, string memory);

    function routePayload(
        CCMPMessage calldata _ccmpMessage,
        bytes calldata _routeArgs
    ) external;
}
