/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../common";

export type GasFeePaymentArgsStruct = {
  feeTokenAddress: PromiseOrValue<string>;
  feeAmount: PromiseOrValue<BigNumberish>;
  relayer: PromiseOrValue<string>;
};

export type GasFeePaymentArgsStructOutput = [string, BigNumber, string] & {
  feeTokenAddress: string;
  feeAmount: BigNumber;
  relayer: string;
};

export type CCMPMessagePayloadStruct = {
  to: PromiseOrValue<string>;
  _calldata: PromiseOrValue<BytesLike>;
};

export type CCMPMessagePayloadStructOutput = [string, string] & {
  to: string;
  _calldata: string;
};

export type CCMPMessageStruct = {
  sender: PromiseOrValue<string>;
  sourceGateway: PromiseOrValue<string>;
  sourceAdaptor: PromiseOrValue<string>;
  sourceChainId: PromiseOrValue<BigNumberish>;
  destinationGateway: PromiseOrValue<string>;
  destinationChainId: PromiseOrValue<BigNumberish>;
  nonce: PromiseOrValue<BigNumberish>;
  routerAdaptor: PromiseOrValue<string>;
  gasFeePaymentArgs: GasFeePaymentArgsStruct;
  payload: CCMPMessagePayloadStruct[];
};

export type CCMPMessageStructOutput = [
  string,
  string,
  string,
  BigNumber,
  string,
  BigNumber,
  BigNumber,
  string,
  GasFeePaymentArgsStructOutput,
  CCMPMessagePayloadStructOutput[]
] & {
  sender: string;
  sourceGateway: string;
  sourceAdaptor: string;
  sourceChainId: BigNumber;
  destinationGateway: string;
  destinationChainId: BigNumber;
  nonce: BigNumber;
  routerAdaptor: string;
  gasFeePaymentArgs: GasFeePaymentArgsStructOutput;
  payload: CCMPMessagePayloadStructOutput[];
};

export interface AbacusAdapterInterface extends utils.Interface {
  functions: {
    "abacusConnectionManager()": FunctionFragment;
    "ccmpGateway()": FunctionFragment;
    "chainIdToAbacusAdaptor(uint256)": FunctionFragment;
    "chainIdToDomainId(uint256)": FunctionFragment;
    "changePauser(address)": FunctionFragment;
    "domainIdToChainId(uint32)": FunctionFragment;
    "getPauser()": FunctionFragment;
    "handle(uint32,bytes32,bytes)": FunctionFragment;
    "interchainGasPaymaster()": FunctionFragment;
    "isPauser(address)": FunctionFragment;
    "messageHashVerified(bytes32)": FunctionFragment;
    "owner()": FunctionFragment;
    "pause()": FunctionFragment;
    "paused()": FunctionFragment;
    "renounceOwnership()": FunctionFragment;
    "renouncePauser()": FunctionFragment;
    "routePayload((address,address,address,uint256,address,uint256,uint256,string,(address,uint256,address),(address,bytes)[]),bytes)": FunctionFragment;
    "setAbacusAdaptor(uint256,address)": FunctionFragment;
    "setAbacusConnectionManager(address)": FunctionFragment;
    "setCCMPGateway(address)": FunctionFragment;
    "setInterchainGasPaymaster(address)": FunctionFragment;
    "transferOwnership(address)": FunctionFragment;
    "unpause()": FunctionFragment;
    "updateDomainId(uint256,uint32)": FunctionFragment;
    "verifyPayload((address,address,address,uint256,address,uint256,uint256,string,(address,uint256,address),(address,bytes)[]),bytes)": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "abacusConnectionManager"
      | "ccmpGateway"
      | "chainIdToAbacusAdaptor"
      | "chainIdToDomainId"
      | "changePauser"
      | "domainIdToChainId"
      | "getPauser"
      | "handle"
      | "interchainGasPaymaster"
      | "isPauser"
      | "messageHashVerified"
      | "owner"
      | "pause"
      | "paused"
      | "renounceOwnership"
      | "renouncePauser"
      | "routePayload"
      | "setAbacusAdaptor"
      | "setAbacusConnectionManager"
      | "setCCMPGateway"
      | "setInterchainGasPaymaster"
      | "transferOwnership"
      | "unpause"
      | "updateDomainId"
      | "verifyPayload"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "abacusConnectionManager",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "ccmpGateway",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "chainIdToAbacusAdaptor",
    values: [PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "chainIdToDomainId",
    values: [PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "changePauser",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "domainIdToChainId",
    values: [PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(functionFragment: "getPauser", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "handle",
    values: [
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BytesLike>,
      PromiseOrValue<BytesLike>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "interchainGasPaymaster",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "isPauser",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "messageHashVerified",
    values: [PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(functionFragment: "owner", values?: undefined): string;
  encodeFunctionData(functionFragment: "pause", values?: undefined): string;
  encodeFunctionData(functionFragment: "paused", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "renounceOwnership",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "renouncePauser",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "routePayload",
    values: [CCMPMessageStruct, PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "setAbacusAdaptor",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setAbacusConnectionManager",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setCCMPGateway",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setInterchainGasPaymaster",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "transferOwnership",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(functionFragment: "unpause", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "updateDomainId",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "verifyPayload",
    values: [CCMPMessageStruct, PromiseOrValue<BytesLike>]
  ): string;

  decodeFunctionResult(
    functionFragment: "abacusConnectionManager",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "ccmpGateway",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "chainIdToAbacusAdaptor",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "chainIdToDomainId",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "changePauser",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "domainIdToChainId",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "getPauser", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "handle", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "interchainGasPaymaster",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "isPauser", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "messageHashVerified",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "pause", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "paused", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "renounceOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "renouncePauser",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "routePayload",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setAbacusAdaptor",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setAbacusConnectionManager",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setCCMPGateway",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setInterchainGasPaymaster",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "unpause", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "updateDomainId",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "verifyPayload",
    data: BytesLike
  ): Result;

  events: {
    "AbacusAdaptorUpdated(uint256,address)": EventFragment;
    "AbacusConnectionManagerSet(address)": EventFragment;
    "AbacusMessageRouted(uint256)": EventFragment;
    "AbacusMessageVerified(bytes32,uint32,uint256,address)": EventFragment;
    "CCMPGatewayUpdated(address)": EventFragment;
    "DomainIdUpdated(uint256,uint32)": EventFragment;
    "InterchainGasPaymasterSet(address)": EventFragment;
    "OwnershipTransferred(address,address)": EventFragment;
    "Paused(address)": EventFragment;
    "PauserChanged(address,address)": EventFragment;
    "Unpaused(address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "AbacusAdaptorUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "AbacusConnectionManagerSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "AbacusMessageRouted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "AbacusMessageVerified"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CCMPGatewayUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "DomainIdUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "InterchainGasPaymasterSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Paused"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PauserChanged"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Unpaused"): EventFragment;
}

export interface AbacusAdaptorUpdatedEventObject {
  chainId: BigNumber;
  newAbacusAdaptor: string;
}
export type AbacusAdaptorUpdatedEvent = TypedEvent<
  [BigNumber, string],
  AbacusAdaptorUpdatedEventObject
>;

export type AbacusAdaptorUpdatedEventFilter =
  TypedEventFilter<AbacusAdaptorUpdatedEvent>;

export interface AbacusConnectionManagerSetEventObject {
  abacusConnectionManager: string;
}
export type AbacusConnectionManagerSetEvent = TypedEvent<
  [string],
  AbacusConnectionManagerSetEventObject
>;

export type AbacusConnectionManagerSetEventFilter =
  TypedEventFilter<AbacusConnectionManagerSetEvent>;

export interface AbacusMessageRoutedEventObject {
  messageId: BigNumber;
}
export type AbacusMessageRoutedEvent = TypedEvent<
  [BigNumber],
  AbacusMessageRoutedEventObject
>;

export type AbacusMessageRoutedEventFilter =
  TypedEventFilter<AbacusMessageRoutedEvent>;

export interface AbacusMessageVerifiedEventObject {
  ccmpMessageHash: string;
  origin: number;
  sourceChainId: BigNumber;
  sender: string;
}
export type AbacusMessageVerifiedEvent = TypedEvent<
  [string, number, BigNumber, string],
  AbacusMessageVerifiedEventObject
>;

export type AbacusMessageVerifiedEventFilter =
  TypedEventFilter<AbacusMessageVerifiedEvent>;

export interface CCMPGatewayUpdatedEventObject {
  newCCMPGateway: string;
}
export type CCMPGatewayUpdatedEvent = TypedEvent<
  [string],
  CCMPGatewayUpdatedEventObject
>;

export type CCMPGatewayUpdatedEventFilter =
  TypedEventFilter<CCMPGatewayUpdatedEvent>;

export interface DomainIdUpdatedEventObject {
  chainId: BigNumber;
  newDomainId: number;
}
export type DomainIdUpdatedEvent = TypedEvent<
  [BigNumber, number],
  DomainIdUpdatedEventObject
>;

export type DomainIdUpdatedEventFilter = TypedEventFilter<DomainIdUpdatedEvent>;

export interface InterchainGasPaymasterSetEventObject {
  interchainGasPaymaster: string;
}
export type InterchainGasPaymasterSetEvent = TypedEvent<
  [string],
  InterchainGasPaymasterSetEventObject
>;

export type InterchainGasPaymasterSetEventFilter =
  TypedEventFilter<InterchainGasPaymasterSetEvent>;

export interface OwnershipTransferredEventObject {
  previousOwner: string;
  newOwner: string;
}
export type OwnershipTransferredEvent = TypedEvent<
  [string, string],
  OwnershipTransferredEventObject
>;

export type OwnershipTransferredEventFilter =
  TypedEventFilter<OwnershipTransferredEvent>;

export interface PausedEventObject {
  account: string;
}
export type PausedEvent = TypedEvent<[string], PausedEventObject>;

export type PausedEventFilter = TypedEventFilter<PausedEvent>;

export interface PauserChangedEventObject {
  previousPauser: string;
  newPauser: string;
}
export type PauserChangedEvent = TypedEvent<
  [string, string],
  PauserChangedEventObject
>;

export type PauserChangedEventFilter = TypedEventFilter<PauserChangedEvent>;

export interface UnpausedEventObject {
  account: string;
}
export type UnpausedEvent = TypedEvent<[string], UnpausedEventObject>;

export type UnpausedEventFilter = TypedEventFilter<UnpausedEvent>;

export interface AbacusAdapter extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: AbacusAdapterInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    abacusConnectionManager(overrides?: CallOverrides): Promise<[string]>;

    ccmpGateway(overrides?: CallOverrides): Promise<[string]>;

    chainIdToAbacusAdaptor(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    chainIdToDomainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[number]>;

    changePauser(
      newPauser: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    domainIdToChainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    getPauser(overrides?: CallOverrides): Promise<[string]>;

    handle(
      _origin: PromiseOrValue<BigNumberish>,
      _sender: PromiseOrValue<BytesLike>,
      _message: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    interchainGasPaymaster(overrides?: CallOverrides): Promise<[string]>;

    isPauser(
      pauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    messageHashVerified(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    owner(overrides?: CallOverrides): Promise<[string]>;

    pause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    paused(overrides?: CallOverrides): Promise<[boolean]>;

    renounceOwnership(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    renouncePauser(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    routePayload(
      _message: CCMPMessageStruct,
      arg1: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setAbacusAdaptor(
      _chainId: PromiseOrValue<BigNumberish>,
      _abacusAdaptor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setAbacusConnectionManager(
      _abacusConnectionManager: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setCCMPGateway(
      _ccmpGateway: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setInterchainGasPaymaster(
      _interchainGasPaymaster: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    transferOwnership(
      newOwner: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    unpause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    updateDomainId(
      _chainId: PromiseOrValue<BigNumberish>,
      _domainId: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      arg1: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[boolean, string]>;
  };

  abacusConnectionManager(overrides?: CallOverrides): Promise<string>;

  ccmpGateway(overrides?: CallOverrides): Promise<string>;

  chainIdToAbacusAdaptor(
    arg0: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<string>;

  chainIdToDomainId(
    arg0: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<number>;

  changePauser(
    newPauser: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  domainIdToChainId(
    arg0: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  getPauser(overrides?: CallOverrides): Promise<string>;

  handle(
    _origin: PromiseOrValue<BigNumberish>,
    _sender: PromiseOrValue<BytesLike>,
    _message: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  interchainGasPaymaster(overrides?: CallOverrides): Promise<string>;

  isPauser(
    pauser: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  messageHashVerified(
    arg0: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  owner(overrides?: CallOverrides): Promise<string>;

  pause(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  paused(overrides?: CallOverrides): Promise<boolean>;

  renounceOwnership(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  renouncePauser(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  routePayload(
    _message: CCMPMessageStruct,
    arg1: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setAbacusAdaptor(
    _chainId: PromiseOrValue<BigNumberish>,
    _abacusAdaptor: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setAbacusConnectionManager(
    _abacusConnectionManager: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setCCMPGateway(
    _ccmpGateway: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setInterchainGasPaymaster(
    _interchainGasPaymaster: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  transferOwnership(
    newOwner: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  unpause(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  updateDomainId(
    _chainId: PromiseOrValue<BigNumberish>,
    _domainId: PromiseOrValue<BigNumberish>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  verifyPayload(
    _ccmpMessage: CCMPMessageStruct,
    arg1: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<[boolean, string]>;

  callStatic: {
    abacusConnectionManager(overrides?: CallOverrides): Promise<string>;

    ccmpGateway(overrides?: CallOverrides): Promise<string>;

    chainIdToAbacusAdaptor(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<string>;

    chainIdToDomainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<number>;

    changePauser(
      newPauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    domainIdToChainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getPauser(overrides?: CallOverrides): Promise<string>;

    handle(
      _origin: PromiseOrValue<BigNumberish>,
      _sender: PromiseOrValue<BytesLike>,
      _message: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<void>;

    interchainGasPaymaster(overrides?: CallOverrides): Promise<string>;

    isPauser(
      pauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    messageHashVerified(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    owner(overrides?: CallOverrides): Promise<string>;

    pause(overrides?: CallOverrides): Promise<void>;

    paused(overrides?: CallOverrides): Promise<boolean>;

    renounceOwnership(overrides?: CallOverrides): Promise<void>;

    renouncePauser(overrides?: CallOverrides): Promise<void>;

    routePayload(
      _message: CCMPMessageStruct,
      arg1: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<void>;

    setAbacusAdaptor(
      _chainId: PromiseOrValue<BigNumberish>,
      _abacusAdaptor: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setAbacusConnectionManager(
      _abacusConnectionManager: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setCCMPGateway(
      _ccmpGateway: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setInterchainGasPaymaster(
      _interchainGasPaymaster: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    transferOwnership(
      newOwner: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    unpause(overrides?: CallOverrides): Promise<void>;

    updateDomainId(
      _chainId: PromiseOrValue<BigNumberish>,
      _domainId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<void>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      arg1: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[boolean, string]>;
  };

  filters: {
    "AbacusAdaptorUpdated(uint256,address)"(
      chainId?: PromiseOrValue<BigNumberish> | null,
      newAbacusAdaptor?: PromiseOrValue<string> | null
    ): AbacusAdaptorUpdatedEventFilter;
    AbacusAdaptorUpdated(
      chainId?: PromiseOrValue<BigNumberish> | null,
      newAbacusAdaptor?: PromiseOrValue<string> | null
    ): AbacusAdaptorUpdatedEventFilter;

    "AbacusConnectionManagerSet(address)"(
      abacusConnectionManager?: PromiseOrValue<string> | null
    ): AbacusConnectionManagerSetEventFilter;
    AbacusConnectionManagerSet(
      abacusConnectionManager?: PromiseOrValue<string> | null
    ): AbacusConnectionManagerSetEventFilter;

    "AbacusMessageRouted(uint256)"(
      messageId?: PromiseOrValue<BigNumberish> | null
    ): AbacusMessageRoutedEventFilter;
    AbacusMessageRouted(
      messageId?: PromiseOrValue<BigNumberish> | null
    ): AbacusMessageRoutedEventFilter;

    "AbacusMessageVerified(bytes32,uint32,uint256,address)"(
      ccmpMessageHash?: PromiseOrValue<BytesLike> | null,
      origin?: PromiseOrValue<BigNumberish> | null,
      sourceChainId?: PromiseOrValue<BigNumberish> | null,
      sender?: null
    ): AbacusMessageVerifiedEventFilter;
    AbacusMessageVerified(
      ccmpMessageHash?: PromiseOrValue<BytesLike> | null,
      origin?: PromiseOrValue<BigNumberish> | null,
      sourceChainId?: PromiseOrValue<BigNumberish> | null,
      sender?: null
    ): AbacusMessageVerifiedEventFilter;

    "CCMPGatewayUpdated(address)"(
      newCCMPGateway?: PromiseOrValue<string> | null
    ): CCMPGatewayUpdatedEventFilter;
    CCMPGatewayUpdated(
      newCCMPGateway?: PromiseOrValue<string> | null
    ): CCMPGatewayUpdatedEventFilter;

    "DomainIdUpdated(uint256,uint32)"(
      chainId?: PromiseOrValue<BigNumberish> | null,
      newDomainId?: PromiseOrValue<BigNumberish> | null
    ): DomainIdUpdatedEventFilter;
    DomainIdUpdated(
      chainId?: PromiseOrValue<BigNumberish> | null,
      newDomainId?: PromiseOrValue<BigNumberish> | null
    ): DomainIdUpdatedEventFilter;

    "InterchainGasPaymasterSet(address)"(
      interchainGasPaymaster?: PromiseOrValue<string> | null
    ): InterchainGasPaymasterSetEventFilter;
    InterchainGasPaymasterSet(
      interchainGasPaymaster?: PromiseOrValue<string> | null
    ): InterchainGasPaymasterSetEventFilter;

    "OwnershipTransferred(address,address)"(
      previousOwner?: PromiseOrValue<string> | null,
      newOwner?: PromiseOrValue<string> | null
    ): OwnershipTransferredEventFilter;
    OwnershipTransferred(
      previousOwner?: PromiseOrValue<string> | null,
      newOwner?: PromiseOrValue<string> | null
    ): OwnershipTransferredEventFilter;

    "Paused(address)"(account?: null): PausedEventFilter;
    Paused(account?: null): PausedEventFilter;

    "PauserChanged(address,address)"(
      previousPauser?: PromiseOrValue<string> | null,
      newPauser?: PromiseOrValue<string> | null
    ): PauserChangedEventFilter;
    PauserChanged(
      previousPauser?: PromiseOrValue<string> | null,
      newPauser?: PromiseOrValue<string> | null
    ): PauserChangedEventFilter;

    "Unpaused(address)"(account?: null): UnpausedEventFilter;
    Unpaused(account?: null): UnpausedEventFilter;
  };

  estimateGas: {
    abacusConnectionManager(overrides?: CallOverrides): Promise<BigNumber>;

    ccmpGateway(overrides?: CallOverrides): Promise<BigNumber>;

    chainIdToAbacusAdaptor(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    chainIdToDomainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    changePauser(
      newPauser: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    domainIdToChainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    getPauser(overrides?: CallOverrides): Promise<BigNumber>;

    handle(
      _origin: PromiseOrValue<BigNumberish>,
      _sender: PromiseOrValue<BytesLike>,
      _message: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    interchainGasPaymaster(overrides?: CallOverrides): Promise<BigNumber>;

    isPauser(
      pauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    messageHashVerified(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    owner(overrides?: CallOverrides): Promise<BigNumber>;

    pause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    paused(overrides?: CallOverrides): Promise<BigNumber>;

    renounceOwnership(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    renouncePauser(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    routePayload(
      _message: CCMPMessageStruct,
      arg1: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setAbacusAdaptor(
      _chainId: PromiseOrValue<BigNumberish>,
      _abacusAdaptor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setAbacusConnectionManager(
      _abacusConnectionManager: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setCCMPGateway(
      _ccmpGateway: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setInterchainGasPaymaster(
      _interchainGasPaymaster: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    transferOwnership(
      newOwner: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    unpause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    updateDomainId(
      _chainId: PromiseOrValue<BigNumberish>,
      _domainId: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      arg1: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    abacusConnectionManager(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    ccmpGateway(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    chainIdToAbacusAdaptor(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    chainIdToDomainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    changePauser(
      newPauser: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    domainIdToChainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    getPauser(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    handle(
      _origin: PromiseOrValue<BigNumberish>,
      _sender: PromiseOrValue<BytesLike>,
      _message: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    interchainGasPaymaster(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    isPauser(
      pauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    messageHashVerified(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    pause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    paused(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    renounceOwnership(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    renouncePauser(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    routePayload(
      _message: CCMPMessageStruct,
      arg1: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setAbacusAdaptor(
      _chainId: PromiseOrValue<BigNumberish>,
      _abacusAdaptor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setAbacusConnectionManager(
      _abacusConnectionManager: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setCCMPGateway(
      _ccmpGateway: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setInterchainGasPaymaster(
      _interchainGasPaymaster: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    transferOwnership(
      newOwner: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    unpause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    updateDomainId(
      _chainId: PromiseOrValue<BigNumberish>,
      _domainId: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      arg1: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
