/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../common";

export type GasFeePaymentArgsStruct = {
  feeTokenAddress: PromiseOrValue<string>;
  feeAmount: PromiseOrValue<BigNumberish>;
  relayer: PromiseOrValue<string>;
};

export type GasFeePaymentArgsStructOutput = [string, BigNumber, string] & {
  feeTokenAddress: string;
  feeAmount: BigNumber;
  relayer: string;
};

export type CCMPMessagePayloadStruct = {
  to: PromiseOrValue<string>;
  _calldata: PromiseOrValue<BytesLike>;
};

export type CCMPMessagePayloadStructOutput = [string, string] & {
  to: string;
  _calldata: string;
};

export type CCMPMessageStruct = {
  sender: PromiseOrValue<string>;
  sourceGateway: PromiseOrValue<string>;
  sourceAdaptor: PromiseOrValue<string>;
  sourceChainId: PromiseOrValue<BigNumberish>;
  destinationGateway: PromiseOrValue<string>;
  destinationChainId: PromiseOrValue<BigNumberish>;
  nonce: PromiseOrValue<BigNumberish>;
  routerAdaptor: PromiseOrValue<string>;
  gasFeePaymentArgs: GasFeePaymentArgsStruct;
  payload: CCMPMessagePayloadStruct[];
};

export type CCMPMessageStructOutput = [
  string,
  string,
  string,
  BigNumber,
  string,
  BigNumber,
  BigNumber,
  string,
  GasFeePaymentArgsStructOutput,
  CCMPMessagePayloadStructOutput[]
] & {
  sender: string;
  sourceGateway: string;
  sourceAdaptor: string;
  sourceChainId: BigNumber;
  destinationGateway: string;
  destinationChainId: BigNumber;
  nonce: BigNumber;
  routerAdaptor: string;
  gasFeePaymentArgs: GasFeePaymentArgsStructOutput;
  payload: CCMPMessagePayloadStructOutput[];
};

export interface WormholeAdaptorInterface extends utils.Interface {
  functions: {
    "ccmpGateway()": FunctionFragment;
    "chainIdToWormholeAdaptor(uint256)": FunctionFragment;
    "changePauser(address)": FunctionFragment;
    "getPauser()": FunctionFragment;
    "isPauser(address)": FunctionFragment;
    "owner()": FunctionFragment;
    "pause()": FunctionFragment;
    "paused()": FunctionFragment;
    "renounceOwnership()": FunctionFragment;
    "renouncePauser()": FunctionFragment;
    "routePayload((address,address,address,uint256,address,uint256,uint256,string,(address,uint256,address),(address,bytes)[]),bytes)": FunctionFragment;
    "setCCMPGateway(address)": FunctionFragment;
    "setWormholeAdaptorAddress(uint256,address)": FunctionFragment;
    "transferOwnership(address)": FunctionFragment;
    "unpause()": FunctionFragment;
    "updateWormhole(address)": FunctionFragment;
    "updateWormholeChainId(uint16,uint256)": FunctionFragment;
    "verifyPayload((address,address,address,uint256,address,uint256,uint256,string,(address,uint256,address),(address,bytes)[]),bytes)": FunctionFragment;
    "womrholeChainIdToChainId(uint16)": FunctionFragment;
    "wormhole()": FunctionFragment;
    "wormholeMessageNonce()": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "ccmpGateway"
      | "chainIdToWormholeAdaptor"
      | "changePauser"
      | "getPauser"
      | "isPauser"
      | "owner"
      | "pause"
      | "paused"
      | "renounceOwnership"
      | "renouncePauser"
      | "routePayload"
      | "setCCMPGateway"
      | "setWormholeAdaptorAddress"
      | "transferOwnership"
      | "unpause"
      | "updateWormhole"
      | "updateWormholeChainId"
      | "verifyPayload"
      | "womrholeChainIdToChainId"
      | "wormhole"
      | "wormholeMessageNonce"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "ccmpGateway",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "chainIdToWormholeAdaptor",
    values: [PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "changePauser",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(functionFragment: "getPauser", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "isPauser",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(functionFragment: "owner", values?: undefined): string;
  encodeFunctionData(functionFragment: "pause", values?: undefined): string;
  encodeFunctionData(functionFragment: "paused", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "renounceOwnership",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "renouncePauser",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "routePayload",
    values: [CCMPMessageStruct, PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "setCCMPGateway",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setWormholeAdaptorAddress",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "transferOwnership",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(functionFragment: "unpause", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "updateWormhole",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "updateWormholeChainId",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "verifyPayload",
    values: [CCMPMessageStruct, PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "womrholeChainIdToChainId",
    values: [PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(functionFragment: "wormhole", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "wormholeMessageNonce",
    values?: undefined
  ): string;

  decodeFunctionResult(
    functionFragment: "ccmpGateway",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "chainIdToWormholeAdaptor",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "changePauser",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "getPauser", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "isPauser", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "pause", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "paused", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "renounceOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "renouncePauser",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "routePayload",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setCCMPGateway",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setWormholeAdaptorAddress",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "unpause", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "updateWormhole",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "updateWormholeChainId",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "verifyPayload",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "womrholeChainIdToChainId",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "wormhole", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "wormholeMessageNonce",
    data: BytesLike
  ): Result;

  events: {
    "CCMPGatewayUpdated(address)": EventFragment;
    "CCMPMessageRoutedViaWormhole(uint32,uint64,uint8)": EventFragment;
    "OwnershipTransferred(address,address)": EventFragment;
    "Paused(address)": EventFragment;
    "PauserChanged(address,address)": EventFragment;
    "Unpaused(address)": EventFragment;
    "WormholeAdaptorUpdated(uint256,address)": EventFragment;
    "WormholeChainIdUpdated(uint16,uint256)": EventFragment;
    "WormholeUpdated(address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "CCMPGatewayUpdated"): EventFragment;
  getEvent(
    nameOrSignatureOrTopic: "CCMPMessageRoutedViaWormhole"
  ): EventFragment;
  getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Paused"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PauserChanged"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Unpaused"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "WormholeAdaptorUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "WormholeChainIdUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "WormholeUpdated"): EventFragment;
}

export interface CCMPGatewayUpdatedEventObject {
  newCCMPGateway: string;
}
export type CCMPGatewayUpdatedEvent = TypedEvent<
  [string],
  CCMPGatewayUpdatedEventObject
>;

export type CCMPGatewayUpdatedEventFilter =
  TypedEventFilter<CCMPGatewayUpdatedEvent>;

export interface CCMPMessageRoutedViaWormholeEventObject {
  wormholeNonce: number;
  sequenceID: BigNumber;
  consistencyLevel: number;
}
export type CCMPMessageRoutedViaWormholeEvent = TypedEvent<
  [number, BigNumber, number],
  CCMPMessageRoutedViaWormholeEventObject
>;

export type CCMPMessageRoutedViaWormholeEventFilter =
  TypedEventFilter<CCMPMessageRoutedViaWormholeEvent>;

export interface OwnershipTransferredEventObject {
  previousOwner: string;
  newOwner: string;
}
export type OwnershipTransferredEvent = TypedEvent<
  [string, string],
  OwnershipTransferredEventObject
>;

export type OwnershipTransferredEventFilter =
  TypedEventFilter<OwnershipTransferredEvent>;

export interface PausedEventObject {
  account: string;
}
export type PausedEvent = TypedEvent<[string], PausedEventObject>;

export type PausedEventFilter = TypedEventFilter<PausedEvent>;

export interface PauserChangedEventObject {
  previousPauser: string;
  newPauser: string;
}
export type PauserChangedEvent = TypedEvent<
  [string, string],
  PauserChangedEventObject
>;

export type PauserChangedEventFilter = TypedEventFilter<PauserChangedEvent>;

export interface UnpausedEventObject {
  account: string;
}
export type UnpausedEvent = TypedEvent<[string], UnpausedEventObject>;

export type UnpausedEventFilter = TypedEventFilter<UnpausedEvent>;

export interface WormholeAdaptorUpdatedEventObject {
  chainId: BigNumber;
  newWormholeAdaptor: string;
}
export type WormholeAdaptorUpdatedEvent = TypedEvent<
  [BigNumber, string],
  WormholeAdaptorUpdatedEventObject
>;

export type WormholeAdaptorUpdatedEventFilter =
  TypedEventFilter<WormholeAdaptorUpdatedEvent>;

export interface WormholeChainIdUpdatedEventObject {
  wormholeChainId: number;
  chainId: BigNumber;
}
export type WormholeChainIdUpdatedEvent = TypedEvent<
  [number, BigNumber],
  WormholeChainIdUpdatedEventObject
>;

export type WormholeChainIdUpdatedEventFilter =
  TypedEventFilter<WormholeChainIdUpdatedEvent>;

export interface WormholeUpdatedEventObject {
  newWormhole: string;
}
export type WormholeUpdatedEvent = TypedEvent<
  [string],
  WormholeUpdatedEventObject
>;

export type WormholeUpdatedEventFilter = TypedEventFilter<WormholeUpdatedEvent>;

export interface WormholeAdaptor extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: WormholeAdaptorInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    ccmpGateway(overrides?: CallOverrides): Promise<[string]>;

    chainIdToWormholeAdaptor(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    changePauser(
      newPauser: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    getPauser(overrides?: CallOverrides): Promise<[string]>;

    isPauser(
      pauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    owner(overrides?: CallOverrides): Promise<[string]>;

    pause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    paused(overrides?: CallOverrides): Promise<[boolean]>;

    renounceOwnership(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    renouncePauser(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    routePayload(
      _message: CCMPMessageStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setCCMPGateway(
      _ccmpGateway: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setWormholeAdaptorAddress(
      _chainId: PromiseOrValue<BigNumberish>,
      _adaptor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    transferOwnership(
      newOwner: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    unpause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    updateWormhole(
      _wormhole: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    updateWormholeChainId(
      _wormholeChainId: PromiseOrValue<BigNumberish>,
      _chainId: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    womrholeChainIdToChainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    wormhole(overrides?: CallOverrides): Promise<[string]>;

    wormholeMessageNonce(overrides?: CallOverrides): Promise<[number]>;
  };

  ccmpGateway(overrides?: CallOverrides): Promise<string>;

  chainIdToWormholeAdaptor(
    arg0: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<string>;

  changePauser(
    newPauser: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  getPauser(overrides?: CallOverrides): Promise<string>;

  isPauser(
    pauser: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  owner(overrides?: CallOverrides): Promise<string>;

  pause(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  paused(overrides?: CallOverrides): Promise<boolean>;

  renounceOwnership(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  renouncePauser(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  routePayload(
    _message: CCMPMessageStruct,
    _routerArgs: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setCCMPGateway(
    _ccmpGateway: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setWormholeAdaptorAddress(
    _chainId: PromiseOrValue<BigNumberish>,
    _adaptor: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  transferOwnership(
    newOwner: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  unpause(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  updateWormhole(
    _wormhole: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  updateWormholeChainId(
    _wormholeChainId: PromiseOrValue<BigNumberish>,
    _chainId: PromiseOrValue<BigNumberish>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  verifyPayload(
    _ccmpMessage: CCMPMessageStruct,
    _verificationData: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  womrholeChainIdToChainId(
    arg0: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  wormhole(overrides?: CallOverrides): Promise<string>;

  wormholeMessageNonce(overrides?: CallOverrides): Promise<number>;

  callStatic: {
    ccmpGateway(overrides?: CallOverrides): Promise<string>;

    chainIdToWormholeAdaptor(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<string>;

    changePauser(
      newPauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    getPauser(overrides?: CallOverrides): Promise<string>;

    isPauser(
      pauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    owner(overrides?: CallOverrides): Promise<string>;

    pause(overrides?: CallOverrides): Promise<void>;

    paused(overrides?: CallOverrides): Promise<boolean>;

    renounceOwnership(overrides?: CallOverrides): Promise<void>;

    renouncePauser(overrides?: CallOverrides): Promise<void>;

    routePayload(
      _message: CCMPMessageStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<void>;

    setCCMPGateway(
      _ccmpGateway: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setWormholeAdaptorAddress(
      _chainId: PromiseOrValue<BigNumberish>,
      _adaptor: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    transferOwnership(
      newOwner: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    unpause(overrides?: CallOverrides): Promise<void>;

    updateWormhole(
      _wormhole: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    updateWormholeChainId(
      _wormholeChainId: PromiseOrValue<BigNumberish>,
      _chainId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<void>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[boolean, string]>;

    womrholeChainIdToChainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    wormhole(overrides?: CallOverrides): Promise<string>;

    wormholeMessageNonce(overrides?: CallOverrides): Promise<number>;
  };

  filters: {
    "CCMPGatewayUpdated(address)"(
      newCCMPGateway?: PromiseOrValue<string> | null
    ): CCMPGatewayUpdatedEventFilter;
    CCMPGatewayUpdated(
      newCCMPGateway?: PromiseOrValue<string> | null
    ): CCMPGatewayUpdatedEventFilter;

    "CCMPMessageRoutedViaWormhole(uint32,uint64,uint8)"(
      wormholeNonce?: PromiseOrValue<BigNumberish> | null,
      sequenceID?: PromiseOrValue<BigNumberish> | null,
      consistencyLevel?: PromiseOrValue<BigNumberish> | null
    ): CCMPMessageRoutedViaWormholeEventFilter;
    CCMPMessageRoutedViaWormhole(
      wormholeNonce?: PromiseOrValue<BigNumberish> | null,
      sequenceID?: PromiseOrValue<BigNumberish> | null,
      consistencyLevel?: PromiseOrValue<BigNumberish> | null
    ): CCMPMessageRoutedViaWormholeEventFilter;

    "OwnershipTransferred(address,address)"(
      previousOwner?: PromiseOrValue<string> | null,
      newOwner?: PromiseOrValue<string> | null
    ): OwnershipTransferredEventFilter;
    OwnershipTransferred(
      previousOwner?: PromiseOrValue<string> | null,
      newOwner?: PromiseOrValue<string> | null
    ): OwnershipTransferredEventFilter;

    "Paused(address)"(account?: null): PausedEventFilter;
    Paused(account?: null): PausedEventFilter;

    "PauserChanged(address,address)"(
      previousPauser?: PromiseOrValue<string> | null,
      newPauser?: PromiseOrValue<string> | null
    ): PauserChangedEventFilter;
    PauserChanged(
      previousPauser?: PromiseOrValue<string> | null,
      newPauser?: PromiseOrValue<string> | null
    ): PauserChangedEventFilter;

    "Unpaused(address)"(account?: null): UnpausedEventFilter;
    Unpaused(account?: null): UnpausedEventFilter;

    "WormholeAdaptorUpdated(uint256,address)"(
      chainId?: PromiseOrValue<BigNumberish> | null,
      newWormholeAdaptor?: PromiseOrValue<string> | null
    ): WormholeAdaptorUpdatedEventFilter;
    WormholeAdaptorUpdated(
      chainId?: PromiseOrValue<BigNumberish> | null,
      newWormholeAdaptor?: PromiseOrValue<string> | null
    ): WormholeAdaptorUpdatedEventFilter;

    "WormholeChainIdUpdated(uint16,uint256)"(
      wormholeChainId?: PromiseOrValue<BigNumberish> | null,
      chainId?: PromiseOrValue<BigNumberish> | null
    ): WormholeChainIdUpdatedEventFilter;
    WormholeChainIdUpdated(
      wormholeChainId?: PromiseOrValue<BigNumberish> | null,
      chainId?: PromiseOrValue<BigNumberish> | null
    ): WormholeChainIdUpdatedEventFilter;

    "WormholeUpdated(address)"(
      newWormhole?: PromiseOrValue<string> | null
    ): WormholeUpdatedEventFilter;
    WormholeUpdated(
      newWormhole?: PromiseOrValue<string> | null
    ): WormholeUpdatedEventFilter;
  };

  estimateGas: {
    ccmpGateway(overrides?: CallOverrides): Promise<BigNumber>;

    chainIdToWormholeAdaptor(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    changePauser(
      newPauser: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    getPauser(overrides?: CallOverrides): Promise<BigNumber>;

    isPauser(
      pauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    owner(overrides?: CallOverrides): Promise<BigNumber>;

    pause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    paused(overrides?: CallOverrides): Promise<BigNumber>;

    renounceOwnership(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    renouncePauser(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    routePayload(
      _message: CCMPMessageStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setCCMPGateway(
      _ccmpGateway: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setWormholeAdaptorAddress(
      _chainId: PromiseOrValue<BigNumberish>,
      _adaptor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    transferOwnership(
      newOwner: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    unpause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    updateWormhole(
      _wormhole: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    updateWormholeChainId(
      _wormholeChainId: PromiseOrValue<BigNumberish>,
      _chainId: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    womrholeChainIdToChainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    wormhole(overrides?: CallOverrides): Promise<BigNumber>;

    wormholeMessageNonce(overrides?: CallOverrides): Promise<BigNumber>;
  };

  populateTransaction: {
    ccmpGateway(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    chainIdToWormholeAdaptor(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    changePauser(
      newPauser: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    getPauser(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    isPauser(
      pauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    pause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    paused(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    renounceOwnership(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    renouncePauser(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    routePayload(
      _message: CCMPMessageStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setCCMPGateway(
      _ccmpGateway: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setWormholeAdaptorAddress(
      _chainId: PromiseOrValue<BigNumberish>,
      _adaptor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    transferOwnership(
      newOwner: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    unpause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    updateWormhole(
      _wormhole: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    updateWormholeChainId(
      _wormholeChainId: PromiseOrValue<BigNumberish>,
      _chainId: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    womrholeChainIdToChainId(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    wormhole(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    wormholeMessageNonce(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
