/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  PayableOverrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../common";

export type GasFeePaymentArgsStruct = {
  feeTokenAddress: PromiseOrValue<string>;
  feeAmount: PromiseOrValue<BigNumberish>;
  relayer: PromiseOrValue<string>;
};

export type GasFeePaymentArgsStructOutput = [string, BigNumber, string] & {
  feeTokenAddress: string;
  feeAmount: BigNumber;
  relayer: string;
};

export type CCMPMessagePayloadStruct = {
  to: PromiseOrValue<string>;
  _calldata: PromiseOrValue<BytesLike>;
};

export type CCMPMessagePayloadStructOutput = [string, string] & {
  to: string;
  _calldata: string;
};

export interface CCMPSendMessageFacetInterface extends utils.Interface {
  functions: {
    "sendMessage(uint256,string,(address,bytes)[],(address,uint256,address),bytes)": FunctionFragment;
  };

  getFunction(nameOrSignatureOrTopic: "sendMessage"): FunctionFragment;

  encodeFunctionData(
    functionFragment: "sendMessage",
    values: [
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<string>,
      CCMPMessagePayloadStruct[],
      GasFeePaymentArgsStruct,
      PromiseOrValue<BytesLike>
    ]
  ): string;

  decodeFunctionResult(
    functionFragment: "sendMessage",
    data: BytesLike
  ): Result;

  events: {
    "CCMPMessageRouted(bytes32,address,address,address,uint256,address,uint256,uint256,string,tuple,tuple[])": EventFragment;
    "FeePaid(address,uint256,address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "CCMPMessageRouted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "FeePaid"): EventFragment;
}

export interface CCMPMessageRoutedEventObject {
  hash: string;
  sender: string;
  sourceGateway: string;
  sourceAdaptor: string;
  sourceChainId: BigNumber;
  destinationGateway: string;
  destinationChainId: BigNumber;
  nonce: BigNumber;
  routerAdaptor: string;
  gasFeePaymentArgs: GasFeePaymentArgsStructOutput;
  payload: CCMPMessagePayloadStructOutput[];
}
export type CCMPMessageRoutedEvent = TypedEvent<
  [
    string,
    string,
    string,
    string,
    BigNumber,
    string,
    BigNumber,
    BigNumber,
    string,
    GasFeePaymentArgsStructOutput,
    CCMPMessagePayloadStructOutput[]
  ],
  CCMPMessageRoutedEventObject
>;

export type CCMPMessageRoutedEventFilter =
  TypedEventFilter<CCMPMessageRoutedEvent>;

export interface FeePaidEventObject {
  _tokenAddress: string;
  _amount: BigNumber;
  _relayer: string;
}
export type FeePaidEvent = TypedEvent<
  [string, BigNumber, string],
  FeePaidEventObject
>;

export type FeePaidEventFilter = TypedEventFilter<FeePaidEvent>;

export interface CCMPSendMessageFacet extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: CCMPSendMessageFacetInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    sendMessage(
      _destinationChainId: PromiseOrValue<BigNumberish>,
      _adaptorName: PromiseOrValue<string>,
      _payloads: CCMPMessagePayloadStruct[],
      _gasFeePaymentArgs: GasFeePaymentArgsStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  sendMessage(
    _destinationChainId: PromiseOrValue<BigNumberish>,
    _adaptorName: PromiseOrValue<string>,
    _payloads: CCMPMessagePayloadStruct[],
    _gasFeePaymentArgs: GasFeePaymentArgsStruct,
    _routerArgs: PromiseOrValue<BytesLike>,
    overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    sendMessage(
      _destinationChainId: PromiseOrValue<BigNumberish>,
      _adaptorName: PromiseOrValue<string>,
      _payloads: CCMPMessagePayloadStruct[],
      _gasFeePaymentArgs: GasFeePaymentArgsStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<boolean>;
  };

  filters: {
    "CCMPMessageRouted(bytes32,address,address,address,uint256,address,uint256,uint256,string,tuple,tuple[])"(
      hash?: PromiseOrValue<BytesLike> | null,
      sender?: PromiseOrValue<string> | null,
      sourceGateway?: null,
      sourceAdaptor?: null,
      sourceChainId?: null,
      destinationGateway?: null,
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      nonce?: null,
      routerAdaptor?: null,
      gasFeePaymentArgs?: null,
      payload?: null
    ): CCMPMessageRoutedEventFilter;
    CCMPMessageRouted(
      hash?: PromiseOrValue<BytesLike> | null,
      sender?: PromiseOrValue<string> | null,
      sourceGateway?: null,
      sourceAdaptor?: null,
      sourceChainId?: null,
      destinationGateway?: null,
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      nonce?: null,
      routerAdaptor?: null,
      gasFeePaymentArgs?: null,
      payload?: null
    ): CCMPMessageRoutedEventFilter;

    "FeePaid(address,uint256,address)"(
      _tokenAddress?: PromiseOrValue<string> | null,
      _amount?: PromiseOrValue<BigNumberish> | null,
      _relayer?: PromiseOrValue<string> | null
    ): FeePaidEventFilter;
    FeePaid(
      _tokenAddress?: PromiseOrValue<string> | null,
      _amount?: PromiseOrValue<BigNumberish> | null,
      _relayer?: PromiseOrValue<string> | null
    ): FeePaidEventFilter;
  };

  estimateGas: {
    sendMessage(
      _destinationChainId: PromiseOrValue<BigNumberish>,
      _adaptorName: PromiseOrValue<string>,
      _payloads: CCMPMessagePayloadStruct[],
      _gasFeePaymentArgs: GasFeePaymentArgsStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    sendMessage(
      _destinationChainId: PromiseOrValue<BigNumberish>,
      _adaptorName: PromiseOrValue<string>,
      _payloads: CCMPMessagePayloadStruct[],
      _gasFeePaymentArgs: GasFeePaymentArgsStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
