/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PayableOverrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../common";

export type GasFeePaymentArgsStruct = {
  feeTokenAddress: PromiseOrValue<string>;
  feeAmount: PromiseOrValue<BigNumberish>;
  relayer: PromiseOrValue<string>;
};

export type GasFeePaymentArgsStructOutput = [string, BigNumber, string] & {
  feeTokenAddress: string;
  feeAmount: BigNumber;
  relayer: string;
};

export type CCMPMessagePayloadStruct = {
  to: PromiseOrValue<string>;
  _calldata: PromiseOrValue<BytesLike>;
};

export type CCMPMessagePayloadStructOutput = [string, string] & {
  to: string;
  _calldata: string;
};

export type CCMPMessageStruct = {
  sender: PromiseOrValue<string>;
  sourceGateway: PromiseOrValue<string>;
  sourceAdaptor: PromiseOrValue<string>;
  sourceChainId: PromiseOrValue<BigNumberish>;
  destinationGateway: PromiseOrValue<string>;
  destinationChainId: PromiseOrValue<BigNumberish>;
  nonce: PromiseOrValue<BigNumberish>;
  routerAdaptor: PromiseOrValue<string>;
  gasFeePaymentArgs: GasFeePaymentArgsStruct;
  payload: CCMPMessagePayloadStruct[];
};

export type CCMPMessageStructOutput = [
  string,
  string,
  string,
  BigNumber,
  string,
  BigNumber,
  BigNumber,
  string,
  GasFeePaymentArgsStructOutput,
  CCMPMessagePayloadStructOutput[]
] & {
  sender: string;
  sourceGateway: string;
  sourceAdaptor: string;
  sourceChainId: BigNumber;
  destinationGateway: string;
  destinationChainId: BigNumber;
  nonce: BigNumber;
  routerAdaptor: string;
  gasFeePaymentArgs: GasFeePaymentArgsStructOutput;
  payload: CCMPMessagePayloadStructOutput[];
};

export interface ICCMPGatewayInterface extends utils.Interface {
  functions: {
    "ccmpExecutor()": FunctionFragment;
    "gateway(uint256)": FunctionFragment;
    "owner()": FunctionFragment;
    "pause()": FunctionFragment;
    "pauser()": FunctionFragment;
    "receiveMessage((address,address,address,uint256,address,uint256,uint256,string,(address,uint256,address),(address,bytes)[]),bytes,bool)": FunctionFragment;
    "routerAdator(string)": FunctionFragment;
    "sendMessage(uint256,string,(address,bytes)[],(address,uint256,address),bytes)": FunctionFragment;
    "setCCMPExecutor(address)": FunctionFragment;
    "setGateway(uint256,address)": FunctionFragment;
    "setPauser(address)": FunctionFragment;
    "setRouterAdaptor(string,address)": FunctionFragment;
    "transferOwnership(address)": FunctionFragment;
    "unpause()": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "ccmpExecutor"
      | "gateway"
      | "owner"
      | "pause"
      | "pauser"
      | "receiveMessage"
      | "routerAdator"
      | "sendMessage"
      | "setCCMPExecutor"
      | "setGateway"
      | "setPauser"
      | "setRouterAdaptor"
      | "transferOwnership"
      | "unpause"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "ccmpExecutor",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "gateway",
    values: [PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(functionFragment: "owner", values?: undefined): string;
  encodeFunctionData(functionFragment: "pause", values?: undefined): string;
  encodeFunctionData(functionFragment: "pauser", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "receiveMessage",
    values: [
      CCMPMessageStruct,
      PromiseOrValue<BytesLike>,
      PromiseOrValue<boolean>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "routerAdator",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "sendMessage",
    values: [
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<string>,
      CCMPMessagePayloadStruct[],
      GasFeePaymentArgsStruct,
      PromiseOrValue<BytesLike>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "setCCMPExecutor",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setGateway",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setPauser",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "setRouterAdaptor",
    values: [PromiseOrValue<string>, PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "transferOwnership",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(functionFragment: "unpause", values?: undefined): string;

  decodeFunctionResult(
    functionFragment: "ccmpExecutor",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "gateway", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "pause", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "pauser", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "receiveMessage",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "routerAdator",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "sendMessage",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setCCMPExecutor",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "setGateway", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "setPauser", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "setRouterAdaptor",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "unpause", data: BytesLike): Result;

  events: {
    "AdaptorUpdated(string,address)": EventFragment;
    "CCMPExecutorUpdated(address)": EventFragment;
    "CCMPMessageExecuted(bytes32,address,address,address,uint256,address,uint256,uint256,string,tuple,tuple[])": EventFragment;
    "CCMPMessageRouted(bytes32,address,address,address,uint256,address,uint256,uint256,string,tuple,tuple[])": EventFragment;
    "CCMPPayloadExecuted(uint256,address,bool,bytes)": EventFragment;
    "ContractPaused()": EventFragment;
    "ContractUnpaused()": EventFragment;
    "FeePaid(address,uint256,address)": EventFragment;
    "GatewayUpdated(uint256,address)": EventFragment;
    "PauserUpdated(address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "AdaptorUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CCMPExecutorUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CCMPMessageExecuted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CCMPMessageRouted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CCMPPayloadExecuted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ContractPaused"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ContractUnpaused"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "FeePaid"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "GatewayUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "PauserUpdated"): EventFragment;
}

export interface AdaptorUpdatedEventObject {
  adaptorName: string;
  adaptor: string;
}
export type AdaptorUpdatedEvent = TypedEvent<
  [string, string],
  AdaptorUpdatedEventObject
>;

export type AdaptorUpdatedEventFilter = TypedEventFilter<AdaptorUpdatedEvent>;

export interface CCMPExecutorUpdatedEventObject {
  _ccmpExecutor: string;
}
export type CCMPExecutorUpdatedEvent = TypedEvent<
  [string],
  CCMPExecutorUpdatedEventObject
>;

export type CCMPExecutorUpdatedEventFilter =
  TypedEventFilter<CCMPExecutorUpdatedEvent>;

export interface CCMPMessageExecutedEventObject {
  hash: string;
  sender: string;
  sourceGateway: string;
  sourceAdaptor: string;
  sourceChainId: BigNumber;
  destinationGateway: string;
  destinationChainId: BigNumber;
  nonce: BigNumber;
  routerAdaptor: string;
  gasFeePaymentArgs: GasFeePaymentArgsStructOutput;
  payload: CCMPMessagePayloadStructOutput[];
}
export type CCMPMessageExecutedEvent = TypedEvent<
  [
    string,
    string,
    string,
    string,
    BigNumber,
    string,
    BigNumber,
    BigNumber,
    string,
    GasFeePaymentArgsStructOutput,
    CCMPMessagePayloadStructOutput[]
  ],
  CCMPMessageExecutedEventObject
>;

export type CCMPMessageExecutedEventFilter =
  TypedEventFilter<CCMPMessageExecutedEvent>;

export interface CCMPMessageRoutedEventObject {
  hash: string;
  sender: string;
  sourceGateway: string;
  sourceAdaptor: string;
  sourceChainId: BigNumber;
  destinationGateway: string;
  destinationChainId: BigNumber;
  nonce: BigNumber;
  routerAdaptor: string;
  gasFeePaymentArgs: GasFeePaymentArgsStructOutput;
  payload: CCMPMessagePayloadStructOutput[];
}
export type CCMPMessageRoutedEvent = TypedEvent<
  [
    string,
    string,
    string,
    string,
    BigNumber,
    string,
    BigNumber,
    BigNumber,
    string,
    GasFeePaymentArgsStructOutput,
    CCMPMessagePayloadStructOutput[]
  ],
  CCMPMessageRoutedEventObject
>;

export type CCMPMessageRoutedEventFilter =
  TypedEventFilter<CCMPMessageRoutedEvent>;

export interface CCMPPayloadExecutedEventObject {
  index: BigNumber;
  contractAddress: string;
  success: boolean;
  returndata: string;
}
export type CCMPPayloadExecutedEvent = TypedEvent<
  [BigNumber, string, boolean, string],
  CCMPPayloadExecutedEventObject
>;

export type CCMPPayloadExecutedEventFilter =
  TypedEventFilter<CCMPPayloadExecutedEvent>;

export interface ContractPausedEventObject {}
export type ContractPausedEvent = TypedEvent<[], ContractPausedEventObject>;

export type ContractPausedEventFilter = TypedEventFilter<ContractPausedEvent>;

export interface ContractUnpausedEventObject {}
export type ContractUnpausedEvent = TypedEvent<[], ContractUnpausedEventObject>;

export type ContractUnpausedEventFilter =
  TypedEventFilter<ContractUnpausedEvent>;

export interface FeePaidEventObject {
  _tokenAddress: string;
  _amount: BigNumber;
  _relayer: string;
}
export type FeePaidEvent = TypedEvent<
  [string, BigNumber, string],
  FeePaidEventObject
>;

export type FeePaidEventFilter = TypedEventFilter<FeePaidEvent>;

export interface GatewayUpdatedEventObject {
  destinationChainId: BigNumber;
  gateway: string;
}
export type GatewayUpdatedEvent = TypedEvent<
  [BigNumber, string],
  GatewayUpdatedEventObject
>;

export type GatewayUpdatedEventFilter = TypedEventFilter<GatewayUpdatedEvent>;

export interface PauserUpdatedEventObject {
  pauser: string;
}
export type PauserUpdatedEvent = TypedEvent<[string], PauserUpdatedEventObject>;

export type PauserUpdatedEventFilter = TypedEventFilter<PauserUpdatedEvent>;

export interface ICCMPGateway extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: ICCMPGatewayInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    ccmpExecutor(
      overrides?: CallOverrides
    ): Promise<[string] & { executor: string }>;

    gateway(
      _chainId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[string] & { gateway_: string }>;

    owner(overrides?: CallOverrides): Promise<[string] & { owner_: string }>;

    pause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    pauser(overrides?: CallOverrides): Promise<[string] & { pauser_: string }>;

    receiveMessage(
      _message: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      _allowPartialCompletion: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    routerAdator(
      name: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[string] & { adaptor: string }>;

    sendMessage(
      _destinationChainId: PromiseOrValue<BigNumberish>,
      _adaptorName: PromiseOrValue<string>,
      _payloads: CCMPMessagePayloadStruct[],
      _gasFeePaymentArgs: GasFeePaymentArgsStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setCCMPExecutor(
      _ccmpExecutor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setGateway(
      _chainId: PromiseOrValue<BigNumberish>,
      _gateway: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setPauser(
      _pauser: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    setRouterAdaptor(
      name: PromiseOrValue<string>,
      adaptor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    transferOwnership(
      _newOwner: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    unpause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  ccmpExecutor(overrides?: CallOverrides): Promise<string>;

  gateway(
    _chainId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<string>;

  owner(overrides?: CallOverrides): Promise<string>;

  pause(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  pauser(overrides?: CallOverrides): Promise<string>;

  receiveMessage(
    _message: CCMPMessageStruct,
    _verificationData: PromiseOrValue<BytesLike>,
    _allowPartialCompletion: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  routerAdator(
    name: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<string>;

  sendMessage(
    _destinationChainId: PromiseOrValue<BigNumberish>,
    _adaptorName: PromiseOrValue<string>,
    _payloads: CCMPMessagePayloadStruct[],
    _gasFeePaymentArgs: GasFeePaymentArgsStruct,
    _routerArgs: PromiseOrValue<BytesLike>,
    overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setCCMPExecutor(
    _ccmpExecutor: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setGateway(
    _chainId: PromiseOrValue<BigNumberish>,
    _gateway: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setPauser(
    _pauser: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  setRouterAdaptor(
    name: PromiseOrValue<string>,
    adaptor: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  transferOwnership(
    _newOwner: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  unpause(
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    ccmpExecutor(overrides?: CallOverrides): Promise<string>;

    gateway(
      _chainId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<string>;

    owner(overrides?: CallOverrides): Promise<string>;

    pause(overrides?: CallOverrides): Promise<void>;

    pauser(overrides?: CallOverrides): Promise<string>;

    receiveMessage(
      _message: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      _allowPartialCompletion: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    routerAdator(
      name: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<string>;

    sendMessage(
      _destinationChainId: PromiseOrValue<BigNumberish>,
      _adaptorName: PromiseOrValue<string>,
      _payloads: CCMPMessagePayloadStruct[],
      _gasFeePaymentArgs: GasFeePaymentArgsStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    setCCMPExecutor(
      _ccmpExecutor: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setGateway(
      _chainId: PromiseOrValue<BigNumberish>,
      _gateway: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setPauser(
      _pauser: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    setRouterAdaptor(
      name: PromiseOrValue<string>,
      adaptor: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    transferOwnership(
      _newOwner: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    unpause(overrides?: CallOverrides): Promise<void>;
  };

  filters: {
    "AdaptorUpdated(string,address)"(
      adaptorName?: PromiseOrValue<string> | null,
      adaptor?: PromiseOrValue<string> | null
    ): AdaptorUpdatedEventFilter;
    AdaptorUpdated(
      adaptorName?: PromiseOrValue<string> | null,
      adaptor?: PromiseOrValue<string> | null
    ): AdaptorUpdatedEventFilter;

    "CCMPExecutorUpdated(address)"(
      _ccmpExecutor?: PromiseOrValue<string> | null
    ): CCMPExecutorUpdatedEventFilter;
    CCMPExecutorUpdated(
      _ccmpExecutor?: PromiseOrValue<string> | null
    ): CCMPExecutorUpdatedEventFilter;

    "CCMPMessageExecuted(bytes32,address,address,address,uint256,address,uint256,uint256,string,tuple,tuple[])"(
      hash?: PromiseOrValue<BytesLike> | null,
      sender?: PromiseOrValue<string> | null,
      sourceGateway?: null,
      sourceAdaptor?: null,
      sourceChainId?: null,
      destinationGateway?: null,
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      nonce?: null,
      routerAdaptor?: null,
      gasFeePaymentArgs?: null,
      payload?: null
    ): CCMPMessageExecutedEventFilter;
    CCMPMessageExecuted(
      hash?: PromiseOrValue<BytesLike> | null,
      sender?: PromiseOrValue<string> | null,
      sourceGateway?: null,
      sourceAdaptor?: null,
      sourceChainId?: null,
      destinationGateway?: null,
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      nonce?: null,
      routerAdaptor?: null,
      gasFeePaymentArgs?: null,
      payload?: null
    ): CCMPMessageExecutedEventFilter;

    "CCMPMessageRouted(bytes32,address,address,address,uint256,address,uint256,uint256,string,tuple,tuple[])"(
      hash?: PromiseOrValue<BytesLike> | null,
      sender?: PromiseOrValue<string> | null,
      sourceGateway?: null,
      sourceAdaptor?: null,
      sourceChainId?: null,
      destinationGateway?: null,
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      nonce?: null,
      routerAdaptor?: null,
      gasFeePaymentArgs?: null,
      payload?: null
    ): CCMPMessageRoutedEventFilter;
    CCMPMessageRouted(
      hash?: PromiseOrValue<BytesLike> | null,
      sender?: PromiseOrValue<string> | null,
      sourceGateway?: null,
      sourceAdaptor?: null,
      sourceChainId?: null,
      destinationGateway?: null,
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      nonce?: null,
      routerAdaptor?: null,
      gasFeePaymentArgs?: null,
      payload?: null
    ): CCMPMessageRoutedEventFilter;

    "CCMPPayloadExecuted(uint256,address,bool,bytes)"(
      index?: PromiseOrValue<BigNumberish> | null,
      contractAddress?: PromiseOrValue<string> | null,
      success?: null,
      returndata?: null
    ): CCMPPayloadExecutedEventFilter;
    CCMPPayloadExecuted(
      index?: PromiseOrValue<BigNumberish> | null,
      contractAddress?: PromiseOrValue<string> | null,
      success?: null,
      returndata?: null
    ): CCMPPayloadExecutedEventFilter;

    "ContractPaused()"(): ContractPausedEventFilter;
    ContractPaused(): ContractPausedEventFilter;

    "ContractUnpaused()"(): ContractUnpausedEventFilter;
    ContractUnpaused(): ContractUnpausedEventFilter;

    "FeePaid(address,uint256,address)"(
      _tokenAddress?: PromiseOrValue<string> | null,
      _amount?: PromiseOrValue<BigNumberish> | null,
      _relayer?: PromiseOrValue<string> | null
    ): FeePaidEventFilter;
    FeePaid(
      _tokenAddress?: PromiseOrValue<string> | null,
      _amount?: PromiseOrValue<BigNumberish> | null,
      _relayer?: PromiseOrValue<string> | null
    ): FeePaidEventFilter;

    "GatewayUpdated(uint256,address)"(
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      gateway?: PromiseOrValue<string> | null
    ): GatewayUpdatedEventFilter;
    GatewayUpdated(
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      gateway?: PromiseOrValue<string> | null
    ): GatewayUpdatedEventFilter;

    "PauserUpdated(address)"(
      pauser?: PromiseOrValue<string> | null
    ): PauserUpdatedEventFilter;
    PauserUpdated(
      pauser?: PromiseOrValue<string> | null
    ): PauserUpdatedEventFilter;
  };

  estimateGas: {
    ccmpExecutor(overrides?: CallOverrides): Promise<BigNumber>;

    gateway(
      _chainId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    owner(overrides?: CallOverrides): Promise<BigNumber>;

    pause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    pauser(overrides?: CallOverrides): Promise<BigNumber>;

    receiveMessage(
      _message: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      _allowPartialCompletion: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    routerAdator(
      name: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    sendMessage(
      _destinationChainId: PromiseOrValue<BigNumberish>,
      _adaptorName: PromiseOrValue<string>,
      _payloads: CCMPMessagePayloadStruct[],
      _gasFeePaymentArgs: GasFeePaymentArgsStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setCCMPExecutor(
      _ccmpExecutor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setGateway(
      _chainId: PromiseOrValue<BigNumberish>,
      _gateway: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setPauser(
      _pauser: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    setRouterAdaptor(
      name: PromiseOrValue<string>,
      adaptor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    transferOwnership(
      _newOwner: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    unpause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    ccmpExecutor(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    gateway(
      _chainId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    pause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    pauser(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    receiveMessage(
      _message: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      _allowPartialCompletion: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    routerAdator(
      name: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    sendMessage(
      _destinationChainId: PromiseOrValue<BigNumberish>,
      _adaptorName: PromiseOrValue<string>,
      _payloads: CCMPMessagePayloadStruct[],
      _gasFeePaymentArgs: GasFeePaymentArgsStruct,
      _routerArgs: PromiseOrValue<BytesLike>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setCCMPExecutor(
      _ccmpExecutor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setGateway(
      _chainId: PromiseOrValue<BigNumberish>,
      _gateway: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setPauser(
      _pauser: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    setRouterAdaptor(
      name: PromiseOrValue<string>,
      adaptor: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    transferOwnership(
      _newOwner: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    unpause(
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
