/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../common";

export type GasFeePaymentArgsStruct = {
  feeTokenAddress: PromiseOrValue<string>;
  feeAmount: PromiseOrValue<BigNumberish>;
  relayer: PromiseOrValue<string>;
};

export type GasFeePaymentArgsStructOutput = [string, BigNumber, string] & {
  feeTokenAddress: string;
  feeAmount: BigNumber;
  relayer: string;
};

export type CCMPMessagePayloadStruct = {
  to: PromiseOrValue<string>;
  _calldata: PromiseOrValue<BytesLike>;
};

export type CCMPMessagePayloadStructOutput = [string, string] & {
  to: string;
  _calldata: string;
};

export type CCMPMessageStruct = {
  sender: PromiseOrValue<string>;
  sourceGateway: PromiseOrValue<string>;
  sourceAdaptor: PromiseOrValue<string>;
  sourceChainId: PromiseOrValue<BigNumberish>;
  destinationGateway: PromiseOrValue<string>;
  destinationChainId: PromiseOrValue<BigNumberish>;
  nonce: PromiseOrValue<BigNumberish>;
  routerAdaptor: PromiseOrValue<string>;
  gasFeePaymentArgs: GasFeePaymentArgsStruct;
  payload: CCMPMessagePayloadStruct[];
};

export type CCMPMessageStructOutput = [
  string,
  string,
  string,
  BigNumber,
  string,
  BigNumber,
  BigNumber,
  string,
  GasFeePaymentArgsStructOutput,
  CCMPMessagePayloadStructOutput[]
] & {
  sender: string;
  sourceGateway: string;
  sourceAdaptor: string;
  sourceChainId: BigNumber;
  destinationGateway: string;
  destinationChainId: BigNumber;
  nonce: BigNumber;
  routerAdaptor: string;
  gasFeePaymentArgs: GasFeePaymentArgsStructOutput;
  payload: CCMPMessagePayloadStructOutput[];
};

export interface ICCMPGatewayReceiverInterface extends utils.Interface {
  functions: {
    "receiveMessage((address,address,address,uint256,address,uint256,uint256,string,(address,uint256,address),(address,bytes)[]),bytes,bool)": FunctionFragment;
  };

  getFunction(nameOrSignatureOrTopic: "receiveMessage"): FunctionFragment;

  encodeFunctionData(
    functionFragment: "receiveMessage",
    values: [
      CCMPMessageStruct,
      PromiseOrValue<BytesLike>,
      PromiseOrValue<boolean>
    ]
  ): string;

  decodeFunctionResult(
    functionFragment: "receiveMessage",
    data: BytesLike
  ): Result;

  events: {
    "CCMPMessageExecuted(bytes32,address,address,address,uint256,address,uint256,uint256,string,tuple,tuple[])": EventFragment;
    "CCMPPayloadExecuted(uint256,address,bool,bytes)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "CCMPMessageExecuted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CCMPPayloadExecuted"): EventFragment;
}

export interface CCMPMessageExecutedEventObject {
  hash: string;
  sender: string;
  sourceGateway: string;
  sourceAdaptor: string;
  sourceChainId: BigNumber;
  destinationGateway: string;
  destinationChainId: BigNumber;
  nonce: BigNumber;
  routerAdaptor: string;
  gasFeePaymentArgs: GasFeePaymentArgsStructOutput;
  payload: CCMPMessagePayloadStructOutput[];
}
export type CCMPMessageExecutedEvent = TypedEvent<
  [
    string,
    string,
    string,
    string,
    BigNumber,
    string,
    BigNumber,
    BigNumber,
    string,
    GasFeePaymentArgsStructOutput,
    CCMPMessagePayloadStructOutput[]
  ],
  CCMPMessageExecutedEventObject
>;

export type CCMPMessageExecutedEventFilter =
  TypedEventFilter<CCMPMessageExecutedEvent>;

export interface CCMPPayloadExecutedEventObject {
  index: BigNumber;
  contractAddress: string;
  success: boolean;
  returndata: string;
}
export type CCMPPayloadExecutedEvent = TypedEvent<
  [BigNumber, string, boolean, string],
  CCMPPayloadExecutedEventObject
>;

export type CCMPPayloadExecutedEventFilter =
  TypedEventFilter<CCMPPayloadExecutedEvent>;

export interface ICCMPGatewayReceiver extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: ICCMPGatewayReceiverInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    receiveMessage(
      _message: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      _allowPartialCompletion: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  receiveMessage(
    _message: CCMPMessageStruct,
    _verificationData: PromiseOrValue<BytesLike>,
    _allowPartialCompletion: PromiseOrValue<boolean>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    receiveMessage(
      _message: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      _allowPartialCompletion: PromiseOrValue<boolean>,
      overrides?: CallOverrides
    ): Promise<boolean>;
  };

  filters: {
    "CCMPMessageExecuted(bytes32,address,address,address,uint256,address,uint256,uint256,string,tuple,tuple[])"(
      hash?: PromiseOrValue<BytesLike> | null,
      sender?: PromiseOrValue<string> | null,
      sourceGateway?: null,
      sourceAdaptor?: null,
      sourceChainId?: null,
      destinationGateway?: null,
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      nonce?: null,
      routerAdaptor?: null,
      gasFeePaymentArgs?: null,
      payload?: null
    ): CCMPMessageExecutedEventFilter;
    CCMPMessageExecuted(
      hash?: PromiseOrValue<BytesLike> | null,
      sender?: PromiseOrValue<string> | null,
      sourceGateway?: null,
      sourceAdaptor?: null,
      sourceChainId?: null,
      destinationGateway?: null,
      destinationChainId?: PromiseOrValue<BigNumberish> | null,
      nonce?: null,
      routerAdaptor?: null,
      gasFeePaymentArgs?: null,
      payload?: null
    ): CCMPMessageExecutedEventFilter;

    "CCMPPayloadExecuted(uint256,address,bool,bytes)"(
      index?: PromiseOrValue<BigNumberish> | null,
      contractAddress?: PromiseOrValue<string> | null,
      success?: null,
      returndata?: null
    ): CCMPPayloadExecutedEventFilter;
    CCMPPayloadExecuted(
      index?: PromiseOrValue<BigNumberish> | null,
      contractAddress?: PromiseOrValue<string> | null,
      success?: null,
      returndata?: null
    ): CCMPPayloadExecutedEventFilter;
  };

  estimateGas: {
    receiveMessage(
      _message: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      _allowPartialCompletion: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    receiveMessage(
      _message: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      _allowPartialCompletion: PromiseOrValue<boolean>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
