/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../common";

export type GasFeePaymentArgsStruct = {
  feeTokenAddress: PromiseOrValue<string>;
  feeAmount: PromiseOrValue<BigNumberish>;
  relayer: PromiseOrValue<string>;
};

export type GasFeePaymentArgsStructOutput = [string, BigNumber, string] & {
  feeTokenAddress: string;
  feeAmount: BigNumber;
  relayer: string;
};

export type CCMPMessagePayloadStruct = {
  to: PromiseOrValue<string>;
  _calldata: PromiseOrValue<BytesLike>;
};

export type CCMPMessagePayloadStructOutput = [string, string] & {
  to: string;
  _calldata: string;
};

export type CCMPMessageStruct = {
  sender: PromiseOrValue<string>;
  sourceGateway: PromiseOrValue<string>;
  sourceAdaptor: PromiseOrValue<string>;
  sourceChainId: PromiseOrValue<BigNumberish>;
  destinationGateway: PromiseOrValue<string>;
  destinationChainId: PromiseOrValue<BigNumberish>;
  nonce: PromiseOrValue<BigNumberish>;
  routerAdaptor: PromiseOrValue<string>;
  gasFeePaymentArgs: GasFeePaymentArgsStruct;
  payload: CCMPMessagePayloadStruct[];
};

export type CCMPMessageStructOutput = [
  string,
  string,
  string,
  BigNumber,
  string,
  BigNumber,
  BigNumber,
  string,
  GasFeePaymentArgsStructOutput,
  CCMPMessagePayloadStructOutput[]
] & {
  sender: string;
  sourceGateway: string;
  sourceAdaptor: string;
  sourceChainId: BigNumber;
  destinationGateway: string;
  destinationChainId: BigNumber;
  nonce: BigNumber;
  routerAdaptor: string;
  gasFeePaymentArgs: GasFeePaymentArgsStructOutput;
  payload: CCMPMessagePayloadStructOutput[];
};

export interface ICCMPRouterAdaptorInterface extends utils.Interface {
  functions: {
    "routePayload((address,address,address,uint256,address,uint256,uint256,string,(address,uint256,address),(address,bytes)[]),bytes)": FunctionFragment;
    "verifyPayload((address,address,address,uint256,address,uint256,uint256,string,(address,uint256,address),(address,bytes)[]),bytes)": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic: "routePayload" | "verifyPayload"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "routePayload",
    values: [CCMPMessageStruct, PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "verifyPayload",
    values: [CCMPMessageStruct, PromiseOrValue<BytesLike>]
  ): string;

  decodeFunctionResult(
    functionFragment: "routePayload",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "verifyPayload",
    data: BytesLike
  ): Result;

  events: {};
}

export interface ICCMPRouterAdaptor extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: ICCMPRouterAdaptorInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    routePayload(
      _ccmpMessage: CCMPMessageStruct,
      _routeArgs: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  routePayload(
    _ccmpMessage: CCMPMessageStruct,
    _routeArgs: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  verifyPayload(
    _ccmpMessage: CCMPMessageStruct,
    _verificationData: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    routePayload(
      _ccmpMessage: CCMPMessageStruct,
      _routeArgs: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<void>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[boolean, string]>;
  };

  filters: {};

  estimateGas: {
    routePayload(
      _ccmpMessage: CCMPMessageStruct,
      _routeArgs: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    routePayload(
      _ccmpMessage: CCMPMessageStruct,
      _routeArgs: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    verifyPayload(
      _ccmpMessage: CCMPMessageStruct,
      _verificationData: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
